var tourItems;
var tourItemsAreOrdered = false;
var sortedTourItems;
var tourName = "My Tour";
var sliderTour;
var getDirections_target_id;

function isTourMode() {
	return tourItems!=undefined;
}

function initTourPanel() {
	 sliderTour = $("#tour-slider").lightSlider({
			gallery: false,
			pager: false,
			item: 3,
			loop: true,
			slide: true,
			slideEndAnimation: false,
			slideMargin: 5,
			enableTouch: true,
			enableDrag: true,
			freeMove: true,
			controls: false,
			onSliderLoad: function (el) {

			},
			onAfterSlide: function (el, scene) {
			//console.log(scene);
			var index = sliderTour.getCurrentSlideCount()
			initForTourItem(index);
			},
		});

}



		
function tourUserLocationChanged() {
	if (isTourMode()) {
		updateTourSliderDOM();
	}

}



	
function initForTourItem(index) {
	//console.log(index);
	//lslide active
	//setMode(mode_unlockAndRotateIcon);	
	if (index == 0)
		index = sortedTourItems.length
	if (index == sortedTourItems.length + 1)
			index = 1
	var itemData = sortedTourItems[index - 1]
	
	//showStaticMarkerOnMapTour(itemData.id,true);
	getDirectionsByIDTour(itemData.id);
}
function getDirectionsByIDTour(target_id,keepMode) {
	resetMapTour();
	navigatorCore.getDirectionsForTargetItem(target_id,keepMode);
	//checkArrived(target_id);
}
function reRouteTour() {
	var currentDestID = navigatorCore.navPathAssistant.itemID
	navigatorCore.getDirectionsForTargetItem(currentDestID,true);
	//checkArrived(currentDestID);
}

function resetMapTour(){
   navigatorCore.navPathAssistant.stopNavigationAssistance()
}


function createTourSliderDOM() {
	//	var slider = $("#top-slider");
	//	for (var key in this.selectableItems) {
	//console.log("processing key =" + key);
	//		this.appendListItemDOMTop(this.selectableItems[key], slider);
	//	}
	var title = $("#tour_overlay").find('#tour_overlay_title')
		title.text(tourName);
	var contentSlider = $("#tour-slider");
	for (var key in sortedTourItems) {
		//console.log("processing key =" + key);
		appendListItemDOM(sortedTourItems[key], contentSlider);
	}

};

function appendListItemDOM(itemData, contentSlider) {

	var li = jQuery('<li/>', {
			target_id: itemData.id
		}).appendTo(contentSlider);

	var distance =navigatorCore.findDistanceToItemM(itemData['id'])
	
	//console.log("distance =" + text);
	var div = jQuery('<div/>', {
			class: "tour_slider_" + itemData['id'] + '_d',
		}).appendTo(li);
	$(div).addClass('slider_item_distance');	
	if(distance){
	  $(div).text(distance);	
	}
	else {
	  $(div).hide();
	}	
		
	var visited = tourItems[itemData['id']]['s'] == 1;

	var span = jQuery('<span/>', {
			class: "tour_slider_" + itemData['id'] + '_v',
			text: 'visited',

		}).appendTo(li)
	span.addClass('slider_item_visited');
	if (visited) {
	} else {
		span.hide();	
	}

	var a = jQuery('<a/>', {
			href: '#',
			target_id: itemData.id,

		}).appendTo(li);

	if (itemData['location_id']) {
		$(a).attr('onclick', "appConnector.tourViewMoreClicked(event);");
		$(a).attr('location_id', itemData['location_id']);
	} else {
		$(a).attr("data-toggle", "modal");
		$(a).attr("data-target", "#item-details-modal-sm");
	}

	var image_span = jQuery('<span/>', {
			//id : 'foo',
			//src : item['th_url'],
			class: 'tour_slider_item_img_span',
		}).appendTo(a);

	var img = jQuery('<img/>', {
			//id : 'foo',
			src: itemData['popupPreviewURL'],
			class: 'slider_img',
			//title : '',
		})
		.appendTo(image_span);

	img['target_id'] = itemData['id'];
	if (itemData['location_id']) {
		//$(a).attr('onclick', "appConnector.tourViewMoreClicked(event);");
		$(img).attr('location_id', itemData['location_id']);
	}
	var title_span = jQuery('<span/>', {
			//id : 'foo',
			//src : item['th_url'],
			class: 'tour_slider_item_title_span',
		}).appendTo(a);

	var title = jQuery('<span/>', {
			//id : 'foo',
			text: itemData['popupHeading'],
			class: 'tour_slider_item_title',
		}).appendTo(title_span);
	//console.log("contentSlider = " + JSON.stringify(contentSlider));
};

function updateTourSliderDOM() {

	for (var key in sortedTourItems) {
		updateListItemDOM(sortedTourItems[key]);
	}

};

function updateListItemDOM(itemData) {
	var distance =navigatorCore.findDistanceToItemM(itemData['id'])
	//	console.log("itemData['id'] =" + itemData['id']);
	//console.log("distance =" + distance);
	//distance = 
	if(distance){
		$(".tour_slider_" + itemData['id']+'_d').text(distance);	
		$(".tour_slider_" + itemData['id']+'_d').show()		  
	}
	else {
		$(".tour_slider_" + itemData['id']+'_d').text(" ");
		$(".tour_slider_" + itemData['id']+'_d').hide()	  
	}
  
	var visited = tourItems[itemData['id']]['s'] == 1;
	if (visited) {		
	 $(".tour_slider_" + itemData['id']+'_v').show()
	} else {
	 $(".tour_slider_" + itemData['id']+'_v').hide();
	}

};

function updateTourItemsStatus(tourItemsStatus) {
	for (var key in tourItemsStatus) {
		if (tourItemsStatus[key]['s'] == 1)
			setVisited(key)
		else
			setNotVisited(key);
		tourItems[key]['s'] = tourItemsStatus[key]['s']
		//var itemData = navigatorCore.navItemFLayer.boundItemsData[tourItems[key]];
	}
	if(sliderTour)
	 updateTourSliderDOM();
 

}

function clearTourItems() {
	resetMap();
}

function removeTourUI() {

	if(sliderTour) sliderTour.destroy();
	$('#tour_arrived_overlay').hide();
	$('#tour-slider').empty();
	$('#tour_overlay').hide();
	popupNav.hide();
	$("#btnDismissNav").show()
	tourName = undefined;
	tourItems = undefined;
	tourItemsAreOrdered = undefined;
	highlightTourItems();
	$('#btnAR').removeClass('tour');
}

function setTourItems(items, ordered, name,target_id) {
	resetMap();
	$(document.body).addClass('tour');
	resetFilterOptions(false);  
	$('#btnSearch').hide()
	$('#btnEye1').hide()
	$('#tour_overlay').show();	
	$("#navigation_overlay").show();	
	$("#btnDismissNav").hide();
	$('#btnAR').addClass('tour');
	tourName = name;
	tourItems = items;
	tourItemsAreOrdered = ordered;
	getDirections_target_id = target_id
	
	var items = [];

	for (var key in tourItems) {
		var itemData = navigatorCore.navItemFLayer.boundItemsData[key];
		if (itemData)
			items.push(itemData);
	}
	//console.log(JSON.stringify(searchResults));
	if (tourItemsAreOrdered){
		items.sort(function (a, b) {
			var distA = tourItems[a['id']]['i'];
			var distB = tourItems[b['id']]['i'];
			if (distA - distB<0) //sort string ascending
				return -1;
			if (distA - distB>0)
				return 1;
			return 0; //default return value (no sorting)
		});
		//var distS = navigatorCore.findDistanceToItem(items[0].id);
		//var distE = navigatorCore.findDistanceToItem(items[items.length-1].id);	
		//console.log(distS+","+distE)
		//if(distS && distE &&(distE<distS))
		//	items.sort(function (a, b) {
		//		var distA = tourItems[a['id']]['i'];
		//		var distB = tourItems[b['id']]['i'];
		//		if (distA - distB>0) //sort string descending
		//			return -1;
		//		if (distA - distB<0)
		//			return 1;
		//		return 0; //default return value (no sorting)
		//	});	
	}
	else 
	{
		items.sort(function (a, b) {
			var distA = navigatorCore.findDistanceToItem(a['id']);
			var distB = navigatorCore.findDistanceToItem(b['id']);
			if (distA < distB) //sort string ascending
				return -1;
			if (distA > distB)
				return 1;
			return 0; //default return value (no sorting)
		});
	}

	sortedTourItems = items;
	highlightTourItems();
	updateTourItemsStatus(tourItems);
	navigatorCore.findAndDisplayTourPath(sortedTourItems);
	createTourSliderDOM();
	initTourPanel();
    $('#map').animate({
    	scrollTop: 0
    }, 500, function () {
    	if (getDirections_target_id != undefined) {
			 scrollToSelectedTourItem(getDirections_target_id);
		
    	} else {
    		initForTourItem(1);
    	}

    });
}

function highlightTourItems() {
	var boundItemsData = navigatorCore.navItemFLayer.boundItemsData;
	for (var key in boundItemsData) {
		var itemData = boundItemsData[key];
		if (itemData['feature'] && itemData['feature']['tourItem']) {
			itemData['feature']['tourItem'] = undefined;
			itemData['feature'].changed();
		}
	}
	for (var key in tourItems) {
		var itemData = navigatorCore.navItemFLayer.boundItemsData[key];
		if (itemData)
			itemData['feature']['tourItem'] = true;
		itemData['feature'].changed();

		//if(key =='SM79751')
		//	itemData['feature']['visited'] = true;

	}

}

function setVisited(key) {
	var itemData = navigatorCore.navItemFLayer.boundItemsData[key];
	if (itemData) {
		itemData['feature']['visited'] = true;
		itemData['feature'].changed();
		updateArrivedOverlay(itemData.id)
	}

}

function setNotVisited(key) {

	var itemData = navigatorCore.navItemFLayer.boundItemsData[key];
	if (itemData)
		itemData['feature']['visited'] = undefined;

}



function showStaticMarkerOnMapTour(marker_id,doNotCenter) {
	//resetMap();
	//getDirectionsByID(marker_id);
	var itemData = navigatorCore.navItemFLayer.boundItemsData[marker_id];
	var feature = itemData['feature']
		if (feature) {
			//insureTypeVisible(itemData.marker_type);

			var coord = feature.getGeometry().getCoordinates();
			popupNav.panMapIfOutOfView=false;
			popupNav.show(coord, createMapPoupHTMLRTour(feature.getId()));
			//map.getView().setCenter(feature.getGeometry().getCoordinates());
			if(!doNotCenter)
			map.getView().animate({
				center: feature.getGeometry().getCoordinates(),
				duration: 500
			});
		}

}

function scrollToSelectedTourItem(targer_id) {
	//alert(targer_id);
	var itemData = navigatorCore.navItemFLayer.boundItemsData[targer_id];
	var slideIndex = sortedTourItems.indexOf(itemData) 
	//alert(slideIndex);
	//popup.hide()
	sliderTour.goToSlide(slideIndex+1);
	//initForTourItem(slideIndex+1);


	
}

function createMapPoupHTMLRTour(itemID) {

	var itemData = navigatorCore.navItemFLayer.boundItemsData[itemID];

	var div = jQuery('<div/>', {})

		a = jQuery('<a/>', {
			//id : 'foo',
			href: "#",
			id: "tour-item-map-popup-link",
			class: "tour-item-map-popup-link",
		//	onclick: "scrollToSelectedTourItem("+"'"+itemID+"'"+")",
		}).appendTo(div);
	a.attr('target-id', itemID);

	
	var divTitleBar = jQuery('<div/>', {
			id : "tour-item-map-popup-title-bar",
			class : "tour-item-map-popup-title-bar"
	}).appendTo(a);


	var span = jQuery('<span/>', {
			id : "tour-item-map-popup-text",
			class : "tour-item-map-popup-text",
			text : itemData['popupHeading']
		}).appendTo(divTitleBar);
	return div.html();
}


function scrollDivTo(divid) {
	//$('#tour-results-list').scrollTop(500)
	//var currentElementTop = currentItemElement.position().top;
	//console.log(currentItemElement);
	//console.log(currentItemElement.offset().top);
	//  $(div).animate({
	//      scrollTop: currentElementTop
	//  }, 1000, function() {
	// lastElement.addClass('current-last');
	//  });

	//$(div).scrollTop(500)

}

function initArrivedOverlay(itemID) {

    // check exits 
	var imgDiv = $('#item-map-arrived-img');
	if(imgDiv && (itemID == imgDiv.attr('target-id'))){
    	return;
	} 
	
	var itemData = navigatorCore.navItemFLayer.boundItemsData[itemID];
	// rgister as visited
	if(tourItems && tourItems[itemID] && tourItems[itemID]['s']==0){
		// register as visited
		registerAsVisisted(itemID)
	} 

	var div = $('#tour_arrived_overlay');
	$(div).empty();

	if (itemData['location_id']) {
		a = jQuery('<a/>', {
				//id : 'foo',
				href : "#",
				onclick : "appConnector.tourViewMoreClicked(event);",
				location_id : itemData['location_id'],
				id : "item-map-arrived-link",
				class : "item-map-arrived-link"
			}).appendTo(div);
	} else  {
				a = jQuery('<div/>', {
			//id : 'foo',
			//href : '#',
			id : "item-map-arrived-link",
			class : "item-map-arrived-link"
		}).appendTo(div);
		
	}	
		
		
	//a.attr('target-id', itemID);

	var divImg = jQuery('<div/>', {
			href : '#',
			id : "item-map-arrived-img",
			class : "item-map-arrived-img"
			
		}).appendTo(a);
	divImg.attr('target-id', itemData.id);
	
	var img = jQuery('<img/>', {
			id : "item-map-arrived-img-img",
			class : "item-map-arrived-img-img",
			src : itemData['popupPreviewURL']
		}).appendTo(divImg);
		
	if (itemData['location_id']) {
		$(img).attr('location_id', itemData['location_id']);
	}		
		
	var divTitleBar = jQuery('<div/>', {
			href : '#',
			id : "item-map-arrived-title-bar",
			class : "item-map-arrived-title-bar"
	}).appendTo(div);
	
	var span = jQuery('<span/>', {
			id : "item-map-arrived-text-prompt",
			class : "item-map-arrived-text-prompt",
			text : langString(language,'map_tour_item_arriving_text_prompt')
		}).appendTo(divTitleBar);

	var span = jQuery('<span/>', {
			id : "item-map-arrived-text",
			class : "item-map-arrived-text",
			text : itemData['popupHeading']
		}).appendTo(divTitleBar);



	jQuery('<br/>', {}).appendTo(span);
	
	var distanceTo = navigatorCore.findDistanceToItemM(itemData['id']);
	if (false && distanceTo)
		var spanDistance = jQuery('<span/>', {
				id : "item-map-arrived-distance",
				class : "item-map-arrived-distance",
				text : distanceTo
			}).appendTo(divImg);
			
	var visited = tourItems && tourItems[itemData['id']] && tourItems[itemData['id']]['s']==1;		
	if(false && visited){

			var span = jQuery('<span/>', {
					class : "label label-info label-pill",
					text : 'visited'
				}).appendTo(divImg)
		}		
	var span_bottom_toolbar = jQuery('<span/>', {
			id : "item-map-arrived-bottom-toolbar",
			class : "item-map-arrived-bottom-toolbar"
	}).appendTo(div);

	

	if(itemData['location_id'] ){	

		var link = jQuery('<a/>', {
			href : '#',
			onclick : "appConnector.tourViewMoreClicked(event);",
			location_id : itemData['location_id'],
			class : "item-map-arrived-view-more",
			//class : "item-map-popup-get-directions-link",
			text :  langString (language, 'info')
		}).appendTo(span_bottom_toolbar);
	}
	
	

}

function initArrivedOverlayTour(itemID) {

    // check exits 
	var imgDiv = $('#item-map-arrived-img');
	if(imgDiv && (itemID == imgDiv.attr('target-id'))){
	//	console.log('exists')
    	return;
	} 
	
	var itemData = navigatorCore.navItemFLayer.boundItemsData[itemID];
	// rgister as visited


	var div = $('#tour_arrived_overlay');
	$(div).empty();

	if (itemData['location_id']) {
		a = jQuery('<a/>', {
				//id : 'foo',
				href: "#",
				onclick : "appConnector.tourViewMoreClicked(event);",
				location_id : itemData['location_id'],
				id: "item-map-arrived-link",
				class: "item-map-arrived-link"
			}).appendTo(div);


	} else {
				a = jQuery('<div/>', {
			//id : 'foo',
			//href : '#',
			id : "item-map-arrived-link",
			class : "item-map-arrived-link"
		}).appendTo(div);
		
	}	
		
		
	//a.attr('target-id', itemID);

	var divImg = jQuery('<div/>', {
			href : '#',
			id : "item-map-arrived-img",
			class : "item-map-arrived-img"
		}).appendTo(a);
	divImg.attr('target-id', itemData.id);
	
	var img = jQuery('<img/>', {
			id : "item-map-arrived-img-img",
			class : "item-map-arrived-img-img",
			src : itemData['popupPreviewURL']
		}).appendTo(divImg);
		
	if (itemData['location_id']) {
		$(img).attr('location_id', itemData['location_id']);
	}		
			
		
	var divTitleBar = jQuery('<div/>', {
			href : '#',
			id : "item-map-arrived-title-bar",
			class : "item-map-arrived-title-bar"
	}).appendTo(div);
	
	var span = jQuery('<span/>', {
			id : "item-map-arrived-text-prompt",
			class : "item-map-arrived-text-prompt",
			text : langString(language,'map_tour_item_arriving_text_prompt')
		}).appendTo(divTitleBar);

	var span = jQuery('<span/>', {
			id : "item-map-arrived-text",
			class : "item-map-arrived-text",
			text : itemData['popupHeading']
		}).appendTo(divTitleBar);



	jQuery('<br/>', {}).appendTo(span);
	
	var distanceTo = navigatorCore.findDistanceToItemM(itemData['id']);
	if (false && distanceTo)
		var spanDistance = jQuery('<span/>', {
				id : "item-map-arrived-distance",
				class : "item-map-arrived-distance",
				text : distanceTo
			}).appendTo(divImg);
			
	var visited = tourItems && tourItems[itemData['id']] && tourItems[itemData['id']]['s']==1;		
	if(false && visited){

			var span = jQuery('<span/>', {
					class : "label label-info label-pill",
					text : 'visited'
				}).appendTo(divImg)
		}		
	var span_bottom_toolbar = jQuery('<span/>', {
			id : "item-map-arrived-bottom-toolbar",
			class : "item-map-arrived-bottom-toolbar"
	}).appendTo(div);

	

	if(itemData['location_id'] ){
		var link = jQuery('<a/>', {
			href : "#",
			onclick : "appConnector.tourViewMoreClicked(event);",
			location_id : itemData['location_id'],
			class : "item-map-arrived-view-more",
			text :  langString (language, 'info')
		}).appendTo(span_bottom_toolbar);
		

	}
	
	var a_dir = jQuery('<a/>', {
			href : '#',
			id : "item-map-arrived-next-link",
			class : "item-map-arrived-next-link",
			onclick : "moveToNextTourItemClicked(event)",
			text : langString(language,'move_to_next_tour_item')
		}).appendTo(span_bottom_toolbar);

	a_dir.attr('target-id', itemData.id);

}

function updateArrivedOverlay(itemID,hasArrived) {
		if(hasArrived)
			$('#item-map-arrived-text-prompt').text( langString(language,'map_tour_item_arrived_text_prompt'))	
		else
			$('#item-map-arrived-text-prompt').text( langString(language,'map_tour_item_arriving_text_prompt'))	
}

function updateArrivedOverlayTour(itemID,hasArrived) {
		var nextLink = $('#item-map-arrived-next-link');
		var target_id = nextLink.attr('target-id')
		if(nextLink && (itemID == target_id)){
			var nextTourItem = findNextTourItem(itemID)
			if(nextTourItem){
				nextLink.text(langString(language,'move_to_next_tour_item'));
				nextLink.attr('href', '#');
				nextLink.attr('onclick', "moveToNextTourItemClicked(event)");
			} else {
				nextLink.text(langString(language,'finish_tour'));
				nextLink.attr('href', '#');	
				nextLink.attr("onclick", "appConnector.finishTourClicked()" );
				
			}
			
		}
		if(hasArrived)
			$('#item-map-arrived-text-prompt').text( langString(language,'map_tour_item_arrived_text_prompt'))	
		else
			$('#item-map-arrived-text-prompt').text( langString(language,'map_tour_item_arriving_text_prompt'))	
}

function moveToNextTourItemClicked(e){
	var target_id = e.target.getAttribute('target-id');
	if (target_id) {
		var nextTourItem = findNextTourItem(target_id)
		if(nextTourItem)
			scrollToSelectedTourItem(nextTourItem.id);

	}

}

function findNextTourItem(currentItemID){
	var currentItemData = navigatorCore.navItemFLayer.boundItemsData[currentItemID];
	var currentItemIndex = sortedTourItems.indexOf(currentItemData)	
	var endIndex = sortedTourItems.length-1;
	var nextTourItem = getNextTourItem(currentItemIndex,endIndex)
	if (!nextTourItem) {
	    endIndex = currentItemIndex;
		nextTourItem =  getNextTourItem(-1,endIndex)
	}
	
	return 	nextTourItem;
	
}

function getNextTourItem(currentItemIndex, endIndex ){
		    if (currentItemIndex < endIndex) {
				var nextItem = sortedTourItems[currentItemIndex+1]
				//return nextItem;
					// not visited
               if( tourItems[nextItem['id']]['s']==0){
					return nextItem;
				} else {
					return getNextTourItem(currentItemIndex+1,endIndex);
				}
			} else {
				// do nothing
			}
}

function registerAsVisisted(itemID) {
	var statusDic = {};
	statusDic[itemID] = {
		's': '1'
	};
	updateTourItemsStatus(statusDic);

	//alert(itemID + " is visited!")
	appConnector.registerAsVisisted(itemID);
}



